clear all; close all;

%
% --- WAVEWATCH III(R) Version 4.07 ---
% Plotting script for wave tracking results created by ww3_systrk
% Andre van der Westhuysen, Dec 2012
%

%--- User Configurable Parameters ------------------ 
direc = '/export/emc-lw-awesthuy/wd20aw/presentations/WW3_Winterschool_2013/svn/WW3_Winter_School_Jan2013/day_1/tutorial_compilation/';
fname{1} = 'ww3.68061200.hs';
fname{2} = 'ww3.68061300.hs';
fname{3} = 'ww3.68061400.hs';
fname{4} = 'ww3.68061500.hs';
fname{5} = 'ww3.68061600.hs';
fname{6} = 'ww3.68061700.hs';
fname{7} = 'ww3.68061800.hs';
%---------------------------------------------------

for it = 1:length(fname);
   fid = fopen([direc cell2mat(fname(it))]);
   display(['Reading ' cell2mat(fname(it)) '...'])
   
   %Header
   readln = fgets(fid);
   params = str2num(readln(16:70));

   timestr{it} = [num2str(params(1))]; % ' ' num2str(params(2),'%6d')];
   xmin = params(3);
   xmax = params(4);
   mx = params(5);
   ymin = params(6);
   ymax = params(7);
   my = params(8);
   xval = xmin:((xmax-xmin)/(mx-1)):xmax;
   yval = ymin:((ymax-ymin)/(my-1)):ymax;
   x = repmat(xval,my,1);
   y = repmat(yval',1,mx);

   scale = str2num(readln(78:83));
   excv = str2num(readln(111:114));

   %Data
   for irow = 1:my
       readln = fgets(fid);
       for icol = 1:32
          indx = icol;
          data{it}.hs(irow,icol) = str2num(readln((2+(indx-1)*4):(1+indx*4)));
       end
       readln = fgets(fid);
       for icol = 33:64
          indx = icol-32;
          data{it}.hs(irow,icol) = str2num(readln((2+(indx-1)*4):(1+indx*4)));
       end 
       readln = fgets(fid);
       for icol = 65:96
          indx = icol-32*2;
          data{it}.hs(irow,icol) = str2num(readln((2+(indx-1)*4):(1+indx*4)));
       end
       readln = fgets(fid);
       for icol = 97:128
          indx = icol-32*3;
          data{it}.hs(irow,icol) = str2num(readln((2+(indx-1)*4):(1+indx*4)));
       end
       readln = fgets(fid);
       for icol = 129:160
          indx = icol-32*4;
          data{it}.hs(irow,icol) = str2num(readln((2+(indx-1)*4):(1+indx*4)));
       end
       readln = fgets(fid);
       for icol = 161:192
          indx = icol-32*5;
          data{it}.hs(irow,icol) = str2num(readln((2+(indx-1)*4):(1+indx*4)));
       end
       readln = fgets(fid);
       for icol = 193:mx
          indx = icol-32*6;
          data{it}.hs(irow,icol) = str2num(readln((2+(indx-1)*4):(1+indx*4)));
       end
end

data{it}.hs(find(data{it}.hs==excv)) = NaN;
data{it}.hs = scale.*data{it}.hs;
end

display(['Plotting...'])

%Figure
for it = 1:length(fname);
   figure(it)
   surf(x,y,data{it}.hs,'Linestyle','none');
   view(2)
   colorbar
   ylim([-90 90])
   zlim([-0.001 0.25]);
   caxis([-0.001 0.25]);
   xlabel('Longitude (deg)')
   ylabel('Latitude (deg)')
   title([timestr{it} ': Significant wave height (m)']);
   axis equal
   box on
   print(gcf,'-dpng',[direc fname{it} '.png'])
   close(it)
end




  